#!/usr/bin/env python

from scipy import log
from sys import argv
import numpy as np

# recupere les valeurs
time = argv[1]
max_dtime = argv[2]
min_dtime = argv[3]
first_dtime = argv[4]

delta = argv[5]
gamma = argv[6]
mobility = argv[7]
D1_alpha = argv[8]
D1_beta = argv[9]
k1_alpha = argv[10]
k1_beta = argv[11]
a1 = argv[12]
a2 = argv[13]
b1 = argv[14]
b2 = argv[15]

mat = open('perlite.mat', 'w')

# ecrit
f = open('input.inp', 'w')
f.write("****calcul\n")
# use mumps for rama 
f.write(" ***linear_solver mumps\n")
f.write(" ***mesh phasefield_chemical\n")
f.write("  **file ./maillage.geof\n")
f.write(" ***resolution\n")
f.write("  **sequence\n")
f.write("   *time "+str(time)+"\n")
f.write("   *algorithm p1p2p3\n")
f.write("   *ratio (absolu Phid:1.e-13 Cd:1.e-5)\n")
#f.write("   *ratio 0.1\n")
f.write("   *increment 10\n")
f.write("   *iteration 20\n")
f.write("  **no_symmetrize\n")
f.write("  **automatic_time global 5\n")
f.write("   *divergence 2. 20\n")
f.write("   *security   1.05\n")
f.write("   *first_dtime "+str(first_dtime)+"\n")
f.write("   *max_dtime "+str(max_dtime)+"\n")
f.write("   *min_dtime "+str(min_dtime)+"\n")

f.write(" ***init_dof_value\n")
f.write("    Phid file Phi.dat 0\n")
f.write("    Cd file C1.dat 0\n")

f.write(" ***bc\n")

f.write("  **flux_cons\n")
f.write("    haut Cd 0.\n")
f.write("    bas Cd 0.\n")
f.write("    gauche Cd 0.\n")
f.write("    droite Cd 0.\n")

f.write("  **impose_nodal_dof\n")
f.write("    gauche Phid 0.\n")
f.write("    droite Phid 0.\n")

f.write(" ***output\n")
f.write("  **frequency\n")
f.write("   *increment 1\n")
           
f.write(" ***material\n")
f.write("  **elset ALL_ELEMENT\n")
f.write("   *file perlite.mat\n")

f.write("****return\n")

mat.write(" ***behavior phasefield_chemical_kks99\n")
mat.write("  **interface\n")
mat.write("   *mobility "+str(mobility)+"\n")
mat.write("   *gamma "+str(gamma)+"\n")
mat.write("   *delta "+str(delta)+"\n")
mat.write("   *zeta 0.05\n")
mat.write("  **interface_energy_function energy_barrier \n")
mat.write("  **chemical\n")
mat.write("   *phase1\n")
mat.write("    a1 "+str(a1)+"\n")
mat.write("    b1 "+str(b1)+"\n")
mat.write("    k1 "+str(k1_alpha)+"\n")
mat.write("    D1 "+str(D1_alpha)+" "+str(D1_alpha)+"\n")
mat.write("   *phase2\n")
mat.write("    a2 "+str(a2)+"\n")
mat.write("    b2 "+str(b2)+"\n")
mat.write("    k2 "+str(k1_beta)+"\n")
mat.write("    D2 "+str(D1_beta)+" "+str(D1_beta)+"\n")
mat.write("  **chemical_interpolating_function cubic_interpolation\n")
mat.write("****return\n")
