#!/usr/bin/env python

from scipy import floor

from sys import argv
from numpy import linspace

import numpy as np

###########################################
# recupere les valeurs
Lx = float(argv[1])
Ly = float(argv[2])

delta = float(argv[3])
##########################################

# densite de maille
dx = delta/10.

Resx = int(floor(Lx/dx))
Resy = 1

elements = Resx*Resy
nodes = (1+Resx)*(1+Resy)

Y = linspace(-Ly/2., Ly/2., Resy+1)
X = linspace(0., Lx, Resx+1)

############################################ 
    
# ecriture du fichier geof
f = open('maillage.geof', 'w')

# geometrie
f.write("***geometry\n")
# noeuds
f.write("**node\n")
f.write(str(nodes)+" 2\n")

compteur = 1
for y in Y:
    for x in X:
          f.write(str(compteur)+" "+str(x)+" "+str(y)+"\n")
          compteur += 1

# elements
f.write("**element\n")
f.write(str(elements)+"\n")

compteur = 1
elem = 1
for y in range(Resy):
    for x in range(Resx):
          f.write(str(elem)+" c2d4 "+str(compteur)+" "+str(compteur+1)+" "+str(compteur+Resx+2)+" "+str(compteur+Resx+1)+"\n")
          compteur += 1
          elem +=1
    compteur += 1
    
f.write("***group\n")
f.write("**nset haut_gauche\n")
f.write(str((Resx+1)*Resy + 1)+" ")
f.write("\n")

f.write("**nset haut\n")
for i in range(1,Resx+2):
    f.write(str((Resx+1)*Resy + i)+" ")
f.write("\n")
    
f.write("**nset bas\n")
for i in range(1,Resx+2):
    f.write(str(i)+" ")
f.write("\n")

f.write("**nset gauche\n")
for i in range(Resy+1):
    f.write(str(1+i*(Resx+1))+" ")
f.write("\n")

f.write("**nset droite\n")
for i in range(1,Resy+2):
    f.write(str(i*(Resx+1))+" ")
f.write("\n")

f.write("**liset haut\n")
for i in range(1,Resx+1):
    f.write("line "+str((Resx+1)*Resy+i)+" "+str((Resx+1)*Resy+i+1)+"\n")

f.write("**liset bas\n")
for i in range(1,Resx+1):
    f.write("line "+str(i)+" "+str(i+1)+"\n")

f.write("**liset gauche\n")
for i in range(Resy):
    f.write("line "+str(1+i*(Resx+1))+" "+str(1+(i+1)*(Resx+1))+"\n")

f.write("**liset droite\n")
for i in range(1,Resy+1):
    f.write("line "+str(i*(Resx+1))+" "+str((i+1)*(Resx+1))+"\n")

f.write("***return\n")
      


