#!/usr/bin/env python

from scipy import tanh, log, sqrt
from sys import argv

import struct, linecache

def h(x):
    return x**2*(3.-2.*x)

# informations sur le maillage 
## import mesh datas
current_file=open("./maillage.geof")
#get number of nodes. it's always on the 3rd line, and it's quicker this way
for i, line in enumerate(current_file):
    if i==2:
        nb_nodes=int(line.split(' ')[0])
    elif i>2:
        break
current_file.close()

#x and y coordinates of the nodes
x=[]
y=[]
for i in range(nb_nodes): #linecache fast for this
    x.append(float(linecache.getline('maillage.geof',i+4).strip('\n').split(' ')[1])) #linecache not zerobased
    y.append(float(linecache.getline('maillage.geof',i+4).strip('\n').split(' ')[2]))
linecache.clearcache()

file_phi=open("Phi.dat",'wb')
file_phi_ci=open("Phi.ci",'w')

file_c1=open("C1.dat",'wb')
file_c1_ci=open("C1.ci",'w')

delta = float(argv[1])
k1    = float(argv[2])
k2    = float(argv[3])

Lambda=delta/log(0.95/0.05)

a1 = float(argv[4])
a2 = float(argv[5])

b1 = float(argv[6])
b2 = float(argv[7])

Omega_alpha = float(argv[8])
Omega_beta  = float(argv[9])

Omega_beta  *= k2/k1 # specific to kks99

x0 = 0.1
y0 = -0.4
r0 = 0.07

x1 = 0.3
y1 = 0.
r1 = 0.2

x2 = 0.7
y2 = 0.1
r2 = 0.15

for i in range(nb_nodes):
    R0 = sqrt((x[i]-x0)**2 + (y[i]-y0)**2) - r0
    R1 = sqrt((x[i]-x1)**2 + (y[i]-y1)**2) - r1
    R2 = sqrt((x[i]-x2)**2 + (y[i]-y2)**2) - r2
    
    phi =  0.5 * (1. - tanh( R0 / Lambda))
    phi += 0.5 * (1. - tanh( R1 / Lambda))
    phi += 0.5 * (1. - tanh( R2 / Lambda))

    h_ = h(phi)
    h_bar = 1-h_

    c1 = h_*(a1 + Omega_alpha) + h_bar*(a1 + Omega_beta)
    
    file_phi.write(struct.pack('>f',phi)) # zebulon in big endian !
    file_phi_ci.write(str(x[i])+'\t'+str(y[-i])+'\t'+str(phi)+'\n')

    file_c1.write(struct.pack('>f',c1)) # zebulon in big endian !
    file_c1_ci.write(str(x[i])+'\t'+str(y[-i])+'\t'+str(c1)+'\n')
