#!/usr/bin/env python

from scipy import log
from sys import argv
import numpy as np

# recupere les valeurs
time        = argv[1]
max_dtime   = argv[2]
min_dtime   = argv[3]
first_dtime = argv[4]

delta    = argv[5]
gamma    = argv[6]
mobility = argv[7]
D1_alpha = argv[8]
D2_alpha = argv[9]
D1_beta  = argv[10] 
D2_beta  = argv[11] 
k1_alpha = argv[12] 
k2_alpha = argv[13] 
k1_beta  = argv[14] 
k2_beta  = argv[15] 
a1       = argv[16] 
a2       = argv[17] 
b1       = argv[18] 
b2       = argv[19] 
eps_star = argv[20] 
E_alpha  = argv[21] 
E_beta   = argv[22] 
n_alpha  = argv[23] 
A_alpha  = argv[24] 
R0_alpha = argv[25] 
n_s_beta = argv[26] 
K_s_beta = argv[27] 
tau_0_beta = argv[28] 
Q_beta   = argv[29] 
b_beta   = argv[30] 
c_beta   = argv[31] 
d_beta   = argv[32] 

mat = open('perlite.mat', 'w')

# ecrit
f = open('input.inp', 'w')
f.write("****calcul\n")
# use mumps for rama 
f.write(" ***linear_solver mumps\n")
f.write(" ***mesh phasefield_chemical_mechanical_plane_strain\n")
f.write("  **file ./maillage.geof\n")
f.write(" ***resolution\n")
f.write("  **sequence\n")
f.write("   *time "+str(time)+"\n")
f.write("   *algorithm p1p2p3\n")
f.write("   *ratio (absolu Phid:1.e-11 C1d:1.e-2 C2d:1.e-2 U:1.e-2)\n")
f.write("   *increment 10\n")
f.write("   *iteration 20\n")
f.write("  **no_symmetrize\n")
f.write("  **automatic_time global 5\n")
f.write("   *divergence 2. 20\n")
f.write("   *security   1.05\n")
f.write("   *first_dtime "+str(first_dtime)+"\n")
f.write("   *max_dtime "+str(max_dtime)+"\n")
f.write("   *min_dtime "+str(min_dtime)+"\n")

f.write(" ***init_dof_value\n")
f.write("    Phid file Phi.dat 0\n")
f.write("    C1d file C1.dat 0\n")
f.write("    C2d uniform 0.\n")

f.write(" ***bc\n")

f.write("  **flux_cons\n")
f.write("    haut C1d 0.\n")
f.write("    bas C1d 0.\n")
f.write("    gauche C1d 0.\n")
f.write("    droite C1d 0.\n")

f.write("  **impose_nodal_dof\n")
f.write("    gauche Phid 0.\n")
f.write("    droite Phid 0.\n")
f.write("    haut U2 0.\n")
f.write("    bas U2 0.\n")
f.write("    gauche U1 0.\n")
f.write("    droite U1 0.\n")

# f.write("  **impose_nodal_reaction\n")
# f.write("    haut_gauche U2 0.2 tab_creep\n") # 200 MPa

# f.write(" ***table\n")
# f.write("  **name tab_creep\n")
# f.write("   *time 0. 1.e-7 1.e+60\n")
# f.write("   *value 0. 1. 1.\n")

f.write(" ***output\n")
f.write("  **frequency\n")
f.write("   *increment 1\n")

# f.write(" ***equation\n")
# f.write("  **mpc1 haut U2\n")

f.write(" ***material\n")
f.write("  **elset ALL_ELEMENT\n")
f.write("   *file perlite.mat\n")
f.write("   *integration runge_kutta 1.e-5 1.e-5\n")
f.write("   *var_mat_ini\n")
f.write("   epsilon_el_alpha11 -"+str(eps_star)+"\n")
f.write("   epsilon_el_alpha22 -"+str(eps_star)+"\n")
f.write("   epsilon_el_alpha33 -"+str(eps_star)+"\n")
f.write("   epsilon_el_alpha12 0.\n")


f.write("****return\n")

mat.write(" ***behavior phasefield_chemical_mechanical_two_component_kks99_nonlinear_cailletaud_norton \n")
mat.write("  **interface\n")
mat.write("   *mobility "+str(mobility)+"\n")
mat.write("   *gamma "+str(gamma)+"\n")
mat.write("   *delta "+str(delta)+"\n")
mat.write("   *zeta 0.05\n")
mat.write("  **interface_energy_function energy_barrier \n")
mat.write("  **chemical\n")
mat.write("   *phase1\n")
mat.write("    a1 "+str(a1)+"\n")
mat.write("    k1_alpha "+str(k1_alpha)+"\n")
mat.write("    D1_alpha "+str(D1_alpha)+" "+str(D1_alpha)+"\n")
mat.write("    a2 "+str(a2)+"\n")
mat.write("    k2_alpha "+str(k2_alpha)+"\n")
mat.write("    D2_alpha "+str(D2_alpha)+" "+str(D2_alpha)+"\n")
mat.write("   *phase2\n")
mat.write("    b1 "+str(b1)+"\n")
mat.write("    k1_beta "+str(k1_beta)+"\n")
mat.write("    D1_beta "+str(D1_beta)+" "+str(D1_beta)+"\n")
mat.write("    b2 "+str(b2)+"\n")
mat.write("    k2_beta "+str(k2_beta)+"\n")
mat.write("    D2_beta "+str(D2_beta)+" "+str(D2_beta)+"\n")
mat.write("  **chemical_interpolating_function cubic_interpolation\n")
mat.write("  **mechanical\n")

mat.write("   *phase1\n")
mat.write("    eigenstrain "+str(eps_star)+" "+str(eps_star)+" "+str(eps_star)+" 0.\n")
mat.write("    vegard 0.\n")
mat.write("    elasticity young "+str(E_alpha)+" poisson 0.3\n")

mat.write("    %% plasticity\n")
mat.write("    % flow rule\n")
mat.write("    A_alpha "+str(A_alpha)+" \n")
mat.write("    n_alpha "+str(n_alpha)+" \n")
mat.write("    R0_alpha "+str(R0_alpha)+" \n")

mat.write("   *phase2\n")
mat.write("    eigenstrain 0. 0. 0. 0.\n")
mat.write("    vegard 0.\n")
mat.write("    elasticity young "+str(E_beta)+" poisson 0.3\n")

mat.write("    %% plasticity\n")
mat.write("    % slip systems\n")
mat.write("    slip_system_beta_file octahedral_2D.sys\n")
mat.write("    slip_system_beta 3\n")

mat.write("    % flow rule\n")
mat.write("    K_s_beta "+str(K_s_beta)+" \n")
mat.write("    n_s_beta "+str(n_s_beta)+" \n")
mat.write("    % isotropic hardening\n")
mat.write("    tau_0_beta "+str(tau_0_beta)+" \n")
mat.write("    Q_beta "+str(Q_beta)+" \n")
mat.write("    b_beta "+str(b_beta)+" \n")
mat.write("    % kinematic hardening\n")
mat.write("    c_beta "+str(c_beta)+" \n")
mat.write("    d_beta "+str(d_beta)+" \n")
mat.write("    % dislocation interaction matrix\n")
mat.write("    w_1_beta 1.\n")
mat.write("    w_2_beta 1.\n")

mat.write("  **mechanical_interpolating_function cubic_interpolation\n")

mat.write("****return\n")
